<?php
/**
 * Plugin Name: blankExploitFixer
 * Plugin URI: http://www.meetjey.com
 * Description: Fix target blank exploit
 * Version: 1.0
 * Author: Meetjey
 * Author URI: http://www.meetjey.com
 * License: GPLv2
 */

if (!defined('ABSPATH'))exit; //Exit if accessed directly

class blankExploitFixer {
  var $textdomain = 'befTxtDom';

  function __construct(){
    add_filter('the_content', array($this, 'fix'), 999);
    add_filter('pre_comment_content', array($this, 'fix'), 999);
    add_action('admin_menu', array($this, 'registerMenu'));
  }

  function fix($content){
    return $this->fixByDom($content);
  }

  function fixByDom($content){
    $dom = new DOMDocument();
    @$dom->loadHTML(mb_convert_encoding($content, 'HTML-ENTITIES', get_bloginfo('charset')));
    $x = new DOMXPath($dom);

    foreach($x->query("//a") as $node)
    {
      if($node->hasAttribute('target') && $node->getAttribute('target') == '_blank')
        $node->setAttribute("rel","noopener noreferrer");
    }
    return $dom->saveHtml();
  }

  function displayDashboard(){
    include "views/dashboard.php";
  }

  function registerMenu($content){
    add_management_page( __('Blank exploit fixer'), __('Blank exploit fixer'), 'manage_options', 'bef-dashboard', array($this, 'displayDashboard') );
  }
}

$blankExploitFixer = new blankExploitFixer();
